"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
class BeancountSymbols {
    constructor(narrations, accounts) {
        this.narrations = narrations;
        this.accounts = accounts;
    }
}
BeancountSymbols.Empty = new BeancountSymbols(new Set(), new Set());
exports.BeancountSymbols = BeancountSymbols;
class BeancountCli {
    constructor(executable) {
        this.executable = executable;
    }
    loadSymbols(file) {
        const narrations = new Set();
        const accounts = new Set();
        //TODO: take the bean-query path from config. This assumes it's on the path
        //TODO: should this be done asynchronously?
        const beanQuery = child_process_1.spawnSync(this.executable, [file, 'SELECT narration, account', "-f=csv"], { env: { 'PYTHONIOENCODING': 'utf_8' }, stdio: 'pipe', encoding: 'utf8' });
        // Output is one line for posting entry, using the following format
        // $NARRATION,$ACCOUNT
        var lines = beanQuery.stdout.toString().split('\n');
        // First line is the header, last is empty
        for (var i = 1; i < lines.length - 1; ++i) {
            const tokens = lines[i].split(",");
            if (tokens.length == 2) {
                narrations.add('"' + tokens[0].trim() + '"');
                accounts.add(tokens[1].trim());
            }
        }
        return new BeancountSymbols(narrations, accounts);
    }
}
exports.BeancountCli = BeancountCli;
//# sourceMappingURL=beancount-cli.js.map