"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Completion {
    constructor(label, insertText) {
        this.label = label;
        this.insertText = insertText;
    }
}
exports.Completion = Completion;
class CompletionOracle {
    constructor(symbols) {
        this.symbols = symbols;
    }
    // Heuristic to decide whether we're dealing with the fist
    // line of a transaction (it starts with a date) or with
    // the lines including the amount associated to a given account.
    // It expects the user to have already inserted the date before
    // invoking auto-completion.
    isTransactionHeader(line) {
        return /^\d+/.test(line.trim());
    }
    complete(line) {
        function toArray(strings, prefix) {
            let result = [];
            strings.forEach(item => result.push(new Completion(item, item.substring(prefix))));
            return result;
        }
        //TODO: compute the lenght of the prefix that is already present
        return this.isTransactionHeader(line)
            ? toArray(this.symbols.narrations, 0)
            : toArray(this.symbols.accounts, 0);
    }
}
exports.CompletionOracle = CompletionOracle;
//# sourceMappingURL=autocomplete.js.map