"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
class BeancountSymbols {
    constructor(narrations, accounts) {
        this.narrations = narrations;
        this.accounts = accounts;
    }
}
BeancountSymbols.Empty = new BeancountSymbols(new Set(), new Set());
exports.BeancountSymbols = BeancountSymbols;
function loadSymbols(file) {
    const narrations = new Set();
    const accounts = new Set();
    //TODO: take the bean-query path from config. This assumes it's on the path
    //TODO: should this be done asynchronously?
    const process = child_process_1.spawnSync("/usr/local/bin/bean-query", [file, "SELECT narration, account", "-f=csv"]);
    // Output is one line for posting entry, using the following format
    // $NARRATION,$ACCOUNT
    process.output.forEach(entry => {
        const tokens = entry.split(',');
        narrations.add('"' + tokens[0].trim() + '"');
        accounts.add(tokens[1].trim());
    });
    return new BeancountSymbols(narrations, accounts);
}
exports.loadSymbols = loadSymbols;
//# sourceMappingURL=beancount-cli.js.map